diff --git a/compiler/typecheck/FamInst.lhs b/compiler/typecheck/FamInst.lhs
index 47cdfa9..a7e8ab5 100644
--- a/compiler/typecheck/FamInst.lhs
+++ b/compiler/typecheck/FamInst.lhs
@@ -2,16 +2,10 @@ The @FamInst@ type: family instance heads
 
 \begin{code}
 {-# LANGUAGE GADTs #-}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module FamInst ( 
         checkFamInstConsistency, tcExtendLocalFamInstEnv,
-	tcLookupFamInst, 
+        tcLookupFamInst, 
         tcGetFamInstEnvs,
         newFamInst,
         TcBuiltInSynFamily(..), trivialBuiltInFamily
@@ -47,9 +41,9 @@ import TcEvidence(TcCoercion)
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
                  Making a FamInst
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -82,9 +76,9 @@ newFamInst flavor axiom@(CoAxiom { co_ax_branches = FirstBranch branch
 
 
 %************************************************************************
-%*									*
-	Optimised overlap checking for family instances
-%*									*
+%*                                                                      *
+        Optimised overlap checking for family instances
+%*                                                                      *
 %************************************************************************
 
 For any two family instance modules that we import directly or indirectly, we
@@ -93,11 +87,11 @@ be certain that the instances of the two modules have already been checked for
 consistency during the compilation of modules that we import.
 
 Why do we need to check?  Consider 
-   module X1 where	  	  module X2 where
-    data T1			    data T2
-    type instance F T1 b = Int	    type instance F a T2 = Char
-    f1 :: F T1 a -> Int		    f2 :: Char -> F a T2
-    f1 x = x			    f2 x = x
+   module X1 where                module X2 where
+    data T1                         data T2
+    type instance F T1 b = Int      type instance F a T2 = Char
+    f1 :: F T1 a -> Int             f2 :: Char -> F a T2
+    f1 x = x                        f2 x = x
 
 Now if we import both X1 and X2 we could make (f2 . f1) :: Int -> Char.
 Notice that neither instance is an orphan.
@@ -118,7 +112,7 @@ data ModulePair = ModulePair Module Module
 --
 canon :: ModulePair -> (Module, Module)
 canon (ModulePair m1 m2) | m1 < m2   = (m1, m2)
-			 | otherwise = (m2, m1)
+                         | otherwise = (m2, m1)
 
 instance Eq ModulePair where
   mp1 == mp2 = canon mp1 == canon mp2
@@ -142,26 +136,26 @@ checkFamInstConsistency famInstMods directlyImpMods
        ; (eps, hpt) <- getEpsAndHpt
 
        ; let { -- Fetch the iface of a given module.  Must succeed as
- 	       -- all directly imported modules must already have been loaded.
-	       modIface mod = 
-	         case lookupIfaceByModule dflags hpt (eps_PIT eps) mod of
+               -- all directly imported modules must already have been loaded.
+               modIface mod = 
+                 case lookupIfaceByModule dflags hpt (eps_PIT eps) mod of
                    Nothing    -> panic "FamInst.checkFamInstConsistency"
                    Just iface -> iface
 
              ; hmiModule     = mi_module . hm_iface
-	     ; hmiFamInstEnv = extendFamInstEnvList emptyFamInstEnv 
+             ; hmiFamInstEnv = extendFamInstEnvList emptyFamInstEnv 
                                . md_fam_insts . hm_details
              ; hpt_fam_insts = mkModuleEnv [ (hmiModule hmi, hmiFamInstEnv hmi) 
-			                   | hmi <- eltsUFM hpt]
-	     ; groups        = map (dep_finsts . mi_deps . modIface) 
-				   directlyImpMods
-	     ; okPairs       = listToSet $ concatMap allPairs groups
-	         -- instances of okPairs are consistent
-	     ; criticalPairs = listToSet $ allPairs famInstMods
-	         -- all pairs that we need to consider
+                                           | hmi <- eltsUFM hpt]
+             ; groups        = map (dep_finsts . mi_deps . modIface) 
+                                   directlyImpMods
+             ; okPairs       = listToSet $ concatMap allPairs groups
+                 -- instances of okPairs are consistent
+             ; criticalPairs = listToSet $ allPairs famInstMods
+                 -- all pairs that we need to consider
              ; toCheckPairs  = Map.keys $ criticalPairs `Map.difference` okPairs
-	         -- the difference gives us the pairs we need to check now
-	     }
+                 -- the difference gives us the pairs we need to check now
+             }
 
        ; mapM_ (check hpt_fam_insts) toCheckPairs
        }
@@ -187,9 +181,9 @@ getFamInsts hpt_fam_insts mod
 \end{code}
 
 %************************************************************************
-%*									*
-	Lookup
-%*									*
+%*                                                                      *
+        Lookup
+%*                                                                      *
 %************************************************************************
 
 Look up the instance tycon of a family instance.
@@ -224,17 +218,17 @@ tcLookupFamInst tycon tys
                                   pprTvBndrs (varSetElems (tyVarsOfTypes tys)) $$ 
                                   ppr mb_match $$ ppr instEnv)
        ; case mb_match of
-	   [] -> return Nothing
-	   (match:_) 
+           [] -> return Nothing
+           (match:_) 
               -> return $ Just match
        }
 \end{code}
 
 
 %************************************************************************
-%*									*
-	Extending the family instance environment
-%*									*
+%*                                                                      *
+        Extending the family instance environment
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -246,7 +240,7 @@ tcExtendLocalFamInstEnv fam_insts thing_inside
                                           (tcg_fam_inst_env env, tcg_fam_insts env)
                                           fam_insts
       ; let env' = env { tcg_fam_insts    = fam_insts'
-		       , tcg_fam_inst_env = inst_env' }
+                       , tcg_fam_inst_env = inst_env' }
       ; setGblEnv env' thing_inside 
       }
 
@@ -285,9 +279,9 @@ addLocalFamInst (home_fie, my_fis) fam_inst
 \end{code}
 
 %************************************************************************
-%*									*
-	Checking an instance against conflicts with an instance env
-%*									*
+%*                                                                      *
+        Checking an instance against conflicts with an instance env
+%*                                                                      *
 %************************************************************************
 
 Check whether a single family instance conflicts with those in two instance
diff --git a/compiler/typecheck/Inst.lhs b/compiler/typecheck/Inst.lhs
index db49902..fb20539 100644
--- a/compiler/typecheck/Inst.lhs
+++ b/compiler/typecheck/Inst.lhs
@@ -6,12 +6,6 @@
 The @Inst@ type: dictionaries or method instances
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module Inst ( 
        deeplySkolemise, 
@@ -35,8 +29,8 @@ module Inst (
 
 #include "HsVersions.h"
 
-import {-# SOURCE #-}	TcExpr( tcPolyExpr, tcSyntaxOp )
-import {-# SOURCE #-}	TcUnify( unifyType )
+import {-# SOURCE #-}   TcExpr( tcPolyExpr, tcSyntaxOp )
+import {-# SOURCE #-}   TcUnify( unifyType )
 
 import FastString
 import HsSyn
@@ -70,9 +64,9 @@ import Data.List( mapAccumL )
 
 
 %************************************************************************
-%*									*
-		Emitting constraints
-%*									*
+%*                                                                      *
+                Emitting constraints
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -95,10 +89,10 @@ newMethodFromName :: CtOrigin -> Name -> TcRhoType -> TcM (HsExpr TcId)
 
 newMethodFromName origin name inst_ty
   = do { id <- tcLookupId name
- 	      -- Use tcLookupId not tcLookupGlobalId; the method is almost
-	      -- always a class op, but with -XRebindableSyntax GHC is
-	      -- meant to find whatever thing is in scope, and that may
-	      -- be an ordinary function. 
+              -- Use tcLookupId not tcLookupGlobalId; the method is almost
+              -- always a class op, but with -XRebindableSyntax GHC is
+              -- meant to find whatever thing is in scope, and that may
+              -- be an ordinary function. 
 
        ; let (tvs, theta, _caller_knows_this) = tcSplitSigmaTy (idType id)
              (the_tv:rest) = tvs
@@ -111,9 +105,9 @@ newMethodFromName origin name inst_ty
 
 
 %************************************************************************
-%*									*
-	Deep instantiation and skolemisation
-%*									*
+%*                                                                      *
+        Deep instantiation and skolemisation
+%*                                                                      *
 %************************************************************************
 
 Note [Deep skolemisation]
@@ -189,23 +183,23 @@ deeplyInstantiate orig ty
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
             Instantiating a call
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 ----------------
 instCall :: CtOrigin -> [TcType] -> TcThetaType -> TcM HsWrapper
 -- Instantiate the constraints of a call
---	(instCall o tys theta)
+--      (instCall o tys theta)
 -- (a) Makes fresh dictionaries as necessary for the constraints (theta)
 -- (b) Throws these dictionaries into the LIE
 -- (c) Returns an HsWrapper ([.] tys dicts)
 
 instCall orig tys theta 
-  = do	{ dict_app <- instCallConstraints orig theta
-	; return (dict_app <.> mkWpTyApps tys) }
+  = do  { dict_app <- instCallConstraints orig theta
+        ; return (dict_app <.> mkWpTyApps tys) }
 
 ----------------
 instCallConstraints :: CtOrigin -> TcThetaType -> TcM HsWrapper
@@ -226,21 +220,21 @@ instCallConstraints orig preds
            ; return (EvCoercion co) }
      | otherwise
      = do { ev_var <- emitWanted orig pred
-     	  ; return (EvId ev_var) }
+          ; return (EvId ev_var) }
 
 ----------------
 instStupidTheta :: CtOrigin -> TcThetaType -> TcM ()
 -- Similar to instCall, but only emit the constraints in the LIE
 -- Used exclusively for the 'stupid theta' of a data constructor
 instStupidTheta orig theta
-  = do	{ _co <- instCallConstraints orig theta -- Discard the coercion
-	; return () }
+  = do  { _co <- instCallConstraints orig theta -- Discard the coercion
+        ; return () }
 \end{code}
 
 %************************************************************************
-%*									*
-		Literals
-%*									*
+%*                                                                      *
+                Literals
+%*                                                                      *
 %************************************************************************
 
 In newOverloadedLit we convert directly to an Int or Integer if we
@@ -264,36 +258,36 @@ newOverloadedLit' :: DynFlags
                   -> TcM (HsOverLit TcId)
 newOverloadedLit' dflags orig
   lit@(OverLit { ol_val = val, ol_rebindable = rebindable
-	       , ol_witness = meth_name }) res_ty
+               , ol_witness = meth_name }) res_ty
 
   | not rebindable
   , Just expr <- shortCutLit dflags val res_ty 
-	-- Do not generate a LitInst for rebindable syntax.  
-	-- Reason: If we do, tcSimplify will call lookupInst, which
-	--	   will call tcSyntaxName, which does unification, 
-	--	   which tcSimplify doesn't like
+        -- Do not generate a LitInst for rebindable syntax.  
+        -- Reason: If we do, tcSimplify will call lookupInst, which
+        --         will call tcSyntaxName, which does unification, 
+        --         which tcSimplify doesn't like
   = return (lit { ol_witness = expr, ol_type = res_ty })
 
   | otherwise
-  = do	{ hs_lit <- mkOverLit val
-	; let lit_ty = hsLitType hs_lit
-	; fi' <- tcSyntaxOp orig meth_name (mkFunTy lit_ty res_ty)
-	 	-- Overloaded literals must have liftedTypeKind, because
-	 	-- we're instantiating an overloaded function here,
-	 	-- whereas res_ty might be openTypeKind. This was a bug in 6.2.2
-		-- However this'll be picked up by tcSyntaxOp if necessary
-	; let witness = HsApp (noLoc fi') (noLoc (HsLit hs_lit))
-	; return (lit { ol_witness = witness, ol_type = res_ty }) }
+  = do  { hs_lit <- mkOverLit val
+        ; let lit_ty = hsLitType hs_lit
+        ; fi' <- tcSyntaxOp orig meth_name (mkFunTy lit_ty res_ty)
+                -- Overloaded literals must have liftedTypeKind, because
+                -- we're instantiating an overloaded function here,
+                -- whereas res_ty might be openTypeKind. This was a bug in 6.2.2
+                -- However this'll be picked up by tcSyntaxOp if necessary
+        ; let witness = HsApp (noLoc fi') (noLoc (HsLit hs_lit))
+        ; return (lit { ol_witness = witness, ol_type = res_ty }) }
 
 ------------
 mkOverLit :: OverLitVal -> TcM HsLit
 mkOverLit (HsIntegral i) 
-  = do	{ integer_ty <- tcMetaTy integerTyConName
-	; return (HsInteger i integer_ty) }
+  = do  { integer_ty <- tcMetaTy integerTyConName
+        ; return (HsInteger i integer_ty) }
 
 mkOverLit (HsFractional r)
-  = do	{ rat_ty <- tcMetaTy rationalTyConName
-	; return (HsRat r rat_ty) }
+  = do  { rat_ty <- tcMetaTy rationalTyConName
+        ; return (HsRat r rat_ty) }
 
 mkOverLit (HsIsString s) = return (HsString s)
 \end{code}
@@ -302,11 +296,11 @@ mkOverLit (HsIsString s) = return (HsString s)
 
 
 %************************************************************************
-%*									*
-		Re-mappable syntax
+%*                                                                      *
+                Re-mappable syntax
     
      Used only for arrow syntax -- find a way to nuke this
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Suppose we are doing the -XRebindableSyntax thing, and we encounter
@@ -319,10 +313,10 @@ this:
 
 So the idea is to generate a local binding for (>>), thus:
 
-	let then72 :: forall a b. m a -> m b -> m b
-	    then72 = ...something involving the user's (>>)...
-	in
-	...the do-expression...
+        let then72 :: forall a b. m a -> m b -> m b
+            then72 = ...something involving the user's (>>)...
+        in
+        ...the do-expression...
 
 Now the do-expression can proceed using then72, which has exactly
 the expected type.
@@ -333,9 +327,9 @@ just use the expression inline.
 
 \begin{code}
 tcSyntaxName :: CtOrigin
-	     -> TcType			-- Type to instantiate it at
-	     -> (Name, HsExpr Name)	-- (Standard name, user name)
-	     -> TcM (Name, HsExpr TcId)	-- (Standard name, suitable expression)
+             -> TcType                  -- Type to instantiate it at
+             -> (Name, HsExpr Name)     -- (Standard name, user name)
+             -> TcM (Name, HsExpr TcId) -- (Standard name, suitable expression)
 -- USED ONLY FOR CmdTop (sigh) ***
 -- See Note [CmdSyntaxTable] in HsExpr
 
@@ -346,18 +340,18 @@ tcSyntaxName orig ty (std_nm, HsVar user_nm)
 
 tcSyntaxName orig ty (std_nm, user_nm_expr) = do
     std_id <- tcLookupId std_nm
-    let	
-	-- C.f. newMethodAtLoc
-	([tv], _, tau)  = tcSplitSigmaTy (idType std_id)
- 	sigma1		= substTyWith [tv] [ty] tau
-	-- Actually, the "tau-type" might be a sigma-type in the
-	-- case of locally-polymorphic methods.
+    let 
+        -- C.f. newMethodAtLoc
+        ([tv], _, tau)  = tcSplitSigmaTy (idType std_id)
+        sigma1          = substTyWith [tv] [ty] tau
+        -- Actually, the "tau-type" might be a sigma-type in the
+        -- case of locally-polymorphic methods.
 
     addErrCtxtM (syntaxNameCtxt user_nm_expr orig sigma1) $ do
 
-	-- Check that the user-supplied thing has the
-	-- same type as the standard one.  
-	-- Tiresome jiggling because tcCheckSigma takes a located expression
+        -- Check that the user-supplied thing has the
+        -- same type as the standard one.  
+        -- Tiresome jiggling because tcCheckSigma takes a located expression
      span <- getSrcSpanM
      expr <- tcPolyExpr (L span user_nm_expr) sigma1
      return (std_nm, unLoc expr)
@@ -367,18 +361,18 @@ syntaxNameCtxt :: HsExpr Name -> CtOrigin -> Type -> TidyEnv
 syntaxNameCtxt name orig ty tidy_env
   = do { inst_loc <- getCtLoc orig
        ; let msg = vcat [ ptext (sLit "When checking that") <+> quotes (ppr name)
-			  <+> ptext (sLit "(needed by a syntactic construct)")
-		        , nest 2 (ptext (sLit "has the required type:")
+                          <+> ptext (sLit "(needed by a syntactic construct)")
+                        , nest 2 (ptext (sLit "has the required type:")
                                   <+> ppr (tidyType tidy_env ty))
-		        , nest 2 (pprArisingAt inst_loc) ]
+                        , nest 2 (pprArisingAt inst_loc) ]
        ; return (tidy_env, msg) }
 \end{code}
 
 
 %************************************************************************
-%*									*
-		Instances
-%*									*
+%*                                                                      *
+                Instances
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -398,7 +392,7 @@ tcGetInstEnvs :: TcM (InstEnv, InstEnv)
 -- Gets both the external-package inst-env
 -- and the home-pkg inst env (includes module being compiled)
 tcGetInstEnvs = do { eps <- getEps; env <- getGblEnv;
-		     return (eps_inst_env eps, tcg_inst_env env) }
+                     return (eps_inst_env eps, tcg_inst_env env) }
 
 tcGetInsts :: TcM [ClsInst]
 -- Gets the local class instances.
@@ -411,7 +405,7 @@ tcExtendLocalInstEnv dfuns thing_inside
       ; env <- getGblEnv
       ; inst_env' <- foldlM addLocalInst (tcg_inst_env env) dfuns
       ; let env' = env { tcg_insts = dfuns ++ tcg_insts env,
-			 tcg_inst_env = inst_env' }
+                         tcg_inst_env = inst_env' }
       ; setGblEnv env' thing_inside }
 
 addLocalInst :: InstEnv -> ClsInst -> TcM InstEnv
@@ -478,7 +472,7 @@ traceDFuns ispecs
   = traceTc "Adding instances:" (vcat (map pp ispecs))
   where
     pp ispec = ppr (instanceDFunId ispec) <+> colon <+> ppr ispec
-	-- Print the dfun name itself too
+        -- Print the dfun name itself too
 
 funDepErr :: ClsInst -> [ClsInst] -> TcRn ()
 funDepErr ispec ispecs
@@ -488,7 +482,7 @@ funDepErr ispec ispecs
 dupInstErr :: ClsInst -> ClsInst -> TcRn ()
 dupInstErr ispec dup_ispec
   = addClsInstsErr (ptext (sLit "Duplicate instance declarations:"))
-	            [ispec, dup_ispec]
+                    [ispec, dup_ispec]
 
 overlappingInstErr :: ClsInst -> ClsInst -> TcRn ()
 overlappingInstErr ispec dup_ispec
@@ -507,9 +501,9 @@ addClsInstsErr herald ispecs
 \end{code}
 
 %************************************************************************
-%*									*
-	Simple functions over evidence variables
-%*									*
+%*                                                                      *
+        Simple functions over evidence variables
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -534,7 +528,7 @@ tyVarsOfCt :: Ct -> TcTyVarSet
 -- NB: the 
 tyVarsOfCt (CTyEqCan { cc_tyvar = tv, cc_rhs = xi })    = extendVarSet (tyVarsOfType xi) tv
 tyVarsOfCt (CFunEqCan { cc_tyargs = tys, cc_rhs = xi }) = tyVarsOfTypes (xi:tys)
-tyVarsOfCt (CDictCan { cc_tyargs = tys }) 	        = tyVarsOfTypes tys
+tyVarsOfCt (CDictCan { cc_tyargs = tys })               = tyVarsOfTypes tys
 tyVarsOfCt (CIrredEvCan { cc_ev = ev })                 = tyVarsOfType (ctEvPred ev)
 tyVarsOfCt (CHoleCan { cc_ev = ev })                    = tyVarsOfType (ctEvPred ev)
 tyVarsOfCt (CNonCanonical { cc_ev = ev })               = tyVarsOfType (ctEvPred ev)
